###############################
## ABDpred Server
## Version 1.0
###############################

from sklearn.model_selection import cross_val_score
from keras import regularizers
from tensorflow import keras
from keras.layers import Dense, Dropout, Flatten
from keras.wrappers.scikit_learn import KerasClassifier
import numpy as np 
import pandas as pd 
import os
from tensorflow.keras.losses import sparse_categorical_crossentropy
from sklearn.preprocessing import StandardScaler
import keras
import tensorflow as tf
import matplotlib.pyplot as plt
import seaborn as sns
from keras.utils import plot_model  
sns.set()
import matplotlib.pyplot as plt

from keras.models import Sequential
from keras.layers import Dense
from sklearn.model_selection import train_test_split
from sklearn.metrics import confusion_matrix,roc_auc_score, classification_report
from sklearn import metrics
from sklearn.metrics import roc_curve, auc, plot_roc_curve
import pickle


#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)



X_train, X_test, y_train, y_test = train_test_split(X, y, test_size = 0.2, random_state = 42)


sc = StandardScaler()
X_train = sc.fit_transform(X_train)
X_test = sc.transform(X_test)




classifier = Sequential()
classifier.add(Flatten())
classifier.add(Dropout(0.45))
classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu', input_dim = 1440, kernel_regularizer=regularizers.l2(0.01)))
classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu'))
classifier.add(Dense(units = 1, kernel_initializer = 'uniform', activation = 'sigmoid'))
classifier.compile(optimizer = 'adam', loss = 'binary_crossentropy', metrics = ['accuracy'])

classifier.fit(X_train, y_train, batch_size = 10, epochs = 100,verbose = 0)
print(classifier.summary())
score, acc = classifier.evaluate(X_train, y_train, batch_size=10)
print('Training score:', score)
print('Training accuracy:', acc)
score, acc = classifier.evaluate(X_test, y_test, batch_size=10)
print('Testing score:', score)
print('Testing accuracy:', acc)
pred_dnn= classifier.predict(X_test)
pred_dnn = (pred_dnn > 0.5)

print(classification_report(y_test,pred_dnn))
tn, fp, fn, tp=confusion_matrix(y_test,pred_dnn).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_dnn)
roc_auc= auc(fpr, tpr)

print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)

classifier.save('saved_model/my_model') 


#new_model = tf.keras.models.load_model('saved_model/my_model')

#new_model.summary()
 

DNN_proba = classifier.predict_proba(X_test)
fpr, tpr, thresholds = roc_curve(y_test, DNN_proba)
plt.plot(fpr,tpr, label='ANN')
plt.xlabel('fpr')
plt.ylabel('tpr')
plt.plot([0,1],[0,1],'k--')
plt.show() 

print("................................")
print("Loaded saved model")
new_model = tf.keras.models.load_model('saved_model/my_model')

new_model.summary()

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']

sc = StandardScaler()
Z = sc.fit_transform(Z)
#z = sc.transform(z)


pred_blind_dnn= classifier.predict(Z)
pred_blind_dnn = (pred_blind_dnn > 0.5)

print(classification_report(z,pred_blind_dnn))
tn, fp, fn, tp=confusion_matrix(z,pred_blind_dnn).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_dnn)
roc_auc= auc(fpr, tpr)

print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)

