###############################
## ABDpred Server
## Version 1.0
###############################


import pandas as pd
import numpy as np
import seaborn as sns
from sklearn.linear_model import LogisticRegression
from sklearn import datasets, metrics, model_selection
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.metrics import roc_curve, auc
from sklearn import metrics
import pickle
import matplotlib.pyplot as plt
from sklearn.metrics import plot_roc_curve


filename="model0"
loaded_model = pickle.load(open(filename, 'rb'))
print (loaded_model)

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
result = loaded_model.score(Z,z)
print(result)

pred_blind_LR=loaded_model.predict(Z)
print("DT Blind Validation classification report: " , classification_report(z, pred_blind_LR))

tn, fp, fn, tp=confusion_matrix(z, pred_blind_LR).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_LR)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)


ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z, z, ax=ax, alpha=0.8)
plt.show()
