###############################
## ABDpred Server
## Version 1.0
###############################



import pandas as pd
import numpy as np
import seaborn as sns
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.metrics import roc_curve, auc
from sklearn import metrics
import pickle
from sklearn.ensemble import RandomForestClassifier

from sklearn.pipeline import make_pipeline
from sklearn.base import BaseEstimator, ClassifierMixin



#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)




rfc = RandomForestClassifier( n_estimators= 200, random_state=92, bootstrap=True, max_features= 'sqrt')




scores_rfc=[]

scores_rfc.append(cross_val_score (rfc,X, y))
#print ("Random Forest Accuracy score using cross val score: ", scores_rfc)
#print(" Random Forest Mean Accuracy score using cross val score", np.mean(scores_rfc))




#print(X.iloc[0])

#print(".............................")
#print("Five fold cross validation using StratifiedKFold.....")

accuracy=[]
specifity_score=[]
sensitivity_score=[]
f1_score=[]
precision_score=[]
AUC_score=[]


skf=StratifiedKFold(n_splits=5, random_state=None)
skf.get_n_splits(X,y)

print ("Fold, Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
i=0
for train_index, test_index in skf.split(X,y):
    #print("Train:", train_index, "Validation", test_index)
    X1_train, X1_test=X.iloc[train_index], X.iloc[test_index]
    y1_train, y1_test=y.iloc[train_index], y.iloc[test_index]
    rfc.fit(X1_train, y1_train)
    prediction=rfc.predict(X1_test)
    
    
    filename = ('model'+str(i))
    #print (filename)
    pickle.dump(rfc, open(filename, 'wb'))
    
    
    
    fpr, tpr, thresholds = metrics.roc_curve(y1_test, prediction)
    AUC=metrics.auc(fpr, tpr)
    AUC_score.append(AUC)
    score=accuracy_score(prediction, y1_test)
    accuracy.append(score)
    tn, fp, fn, tp=confusion_matrix(y1_test, prediction).ravel()
    specificity=(tn/1.0)/(fp+tn)
    sensitivity = (tp)/(tp+fn)
    f1=(2*tp)/(2*tp+fp+fn)
    precision=(tp)/(tp+fp)
    
    #print(i,sensitivity,specificity,score,precision,f1, AUC)
    sensitivity_score.append(sensitivity)
    specifity_score.append(specificity)
    f1_score.append(f1)
    precision_score.append(precision)
    
    #print ("fold",i,tn)
    #print ("fold",i,fp)
    #print ("fold",i,fn)
    #print ("fold",i,tp)
    
    #filename = ('model'+str(i))
    #loaded_model = pickle.load(open(filename, 'rb'))
    #resulting = loaded_model.score(X1_test, y1_test)
    #print("Accuracy made by model", filename, resulting)
    class CustomThreshold(BaseEstimator, ClassifierMixin): 
    
        def __init__(self, base, threshold=0.5): 
            self.base = base 
            self.threshold = threshold 
        def fit(self, *args, **kwargs): 
            self.base.fit(*args, **kwargs) 
            return self 
        def predict(self, X): 
            return (self.base.predict_proba(X)[:, 1] > self.threshold).astype(int)
        
        
        
    cfa = [CustomThreshold(rfc, threshold) for threshold in [0.5]]
    
    for model in cfa: 
        a,b=confusion_matrix(y1_test, model.predict(X1_test))
        
        #print (b[0])
        tnn =a[0]
        fpp=a[1]
        fnn=b[0] 
        tpp=b[1]
        specificityy=(tnn/1.0)/(fpp+tnn)
        sensitivityy =(tpp)/(tp+fn)
        f11=(2*tpp)/(2*tpp+fpp+fnn)
        precisionn=(tpp)/(tpp+fpp)
        acc=(tpp+tnn)/(tpp+tnn+fpp+fnn)
        print ("---after threshold tuning---------------------------------------")
        print ("Sensitivity","Specificity","Accuracy","precision", "f1-score")
        print(sensitivityy,specificityy,acc, precisionn,f11)
        print ("------------------------------------------")
    
    i=i+1
    
#print ("Accuracy array:", accuracy)
#print(".............................")
#print ("Avg_Sensitivity","Avg_Specificity","Avg_Accuracy","Avg_precision", "Avg_f1-score","Avg_AUC")

#print(np.mean(sensitivity_score), np.mean(specifity_score), np.mean(accuracy), np.mean(precision_score), np.mean(f1_score), np.mean(AUC_score))

#print ("After five fold cross validation sensitivity_score: ", np.mean(sensitivity_score))
#print ("After five fold cross validation specifity_score: ", np.mean(specifity_score))
#print("After five fold cross validation average Accuracy score:", np.mean(accuracy))
#print ("After five fold cross validation precision_score: ", np.mean(precision_score))
#print ("After five fold cross validation f1_score: ", np.mean(f1_score))

