###############################
## ABDpred Server
## Version 1.0
###############################


import pandas as pd
import numpy as np
import seaborn as sns
from sklearn.ensemble import RandomForestClassifier
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.metrics import roc_curve, auc
from sklearn import metrics
import pickle
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
from sklearn.metrics import roc_curve, auc
from sklearn.metrics import plot_roc_curve
from sklearn.svm import LinearSVC
from sklearn.feature_selection import SelectFromModel





#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)



X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)


rfc = RandomForestClassifier( n_estimators= 200, random_state=92, bootstrap=True, max_features= 'sqrt')
rfc.fit(X_train,y_train)
print ("Random Forest Training classifier Scores: \n", rfc.score (X_test,y_test))
pred_rfc=rfc.predict(X_test)
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_rfc)
print ("Threshold value: ", thresholds)
print("Random Forest Training report: " , classification_report(y_test, pred_rfc))
print ("AUC Values: ", metrics.auc(fpr, tpr))
print (confusion_matrix(y_test, pred_rfc).ravel())
tn, fp, fn, tp=confusion_matrix(y_test, pred_rfc).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
roc_auc= auc(fpr, tpr)


print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)


filename = ('model_train_test_split_1_1_RF')
pickle.dump(rfc, open(filename, 'wb'))


#plot_confusion_matrix(rfc, X_test, y_test)

ax = plt.gca()
rfc_disp = plot_roc_curve(rfc, X_test, y_test, ax=ax, alpha=0.8)
#plt.savefig('plot2.png')
plt.show() 


filename="model_train_test_split_1_1_RF"
loaded_model = pickle.load(open(filename, 'rb'))
print (loaded_model)

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
result = loaded_model.score(Z,z)
print(result)

pred_blind_rfc=loaded_model.predict(Z)
print("Random Forest Blind Validation classification report: " , classification_report(z, pred_blind_rfc))


tn, fp, fn, tp=confusion_matrix(z, pred_blind_rfc).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_rfc)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)

ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z, z, ax=ax, alpha=0.8)
plt.show()









