###############################
## ABDpred Server
## Version 1.0
###############################




from sklearn.ensemble import RandomForestClassifier
import numpy as np
import seaborn as sns
import matplotlib.pyplot as plt
from sklearn.svm import SVC
from sklearn import svm
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.preprocessing import StandardScaler, LabelEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
import matplotlib.pyplot as plt  # doctest: +SKIP
from sklearn import datasets, metrics, model_selection, svm
from sklearn.metrics import plot_roc_curve
from sklearn.svm import LinearSVC
from sklearn.feature_selection import SelectFromModel
from sklearn import metrics
import pandas as pd
from sklearn.metrics import roc_curve, auc
import pickle
from sklearn.ensemble import ExtraTreesClassifier
from sklearn.feature_selection import SelectFromModel


#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)

clf = ExtraTreesClassifier(n_estimators=50)
clf = clf.fit(X, y)
clf.feature_importances_  
model = SelectFromModel(clf, prefit=True)
X_new = model.transform(X)


print (X_new.shape)
#print (X_new[:2])




X_train, X_test, y_train, y_test = train_test_split(X_new,y, test_size=0.20, random_state=92)



rfc = RandomForestClassifier( n_estimators= 200, random_state=92, bootstrap=True, max_features= 'sqrt')
rfc.fit(X_train,y_train)

print ("RFC classifier Training_Testing Scores: ", rfc.score (X_test, y_test))
predictions=  rfc.predict(X_test)

print("Random Forest classifier  Training_Testingset classification_report:  ", classification_report(y_test, predictions))

fpr, tpr, thresholds = metrics.roc_curve(y_test, predictions)
print ("AUC Values: ", metrics.auc(fpr, tpr))

print ("Random Forest Training classifier Scores: \n", rfc.score (X_test,y_test))
pred_rfc=rfc.predict(X_test)
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_rfc)
print ("Threshold value: ", thresholds)
print("Random Forest Training report: " , classification_report(y_test, pred_rfc))
print ("AUC Values: ", metrics.auc(fpr, tpr))
print (confusion_matrix(y_test, pred_rfc).ravel())
tn, fp, fn, tp=confusion_matrix(y_test, pred_rfc).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
roc_auc= auc(fpr, tpr)


print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")

print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)

filename = ('model_train_test_split_1_1_tree_RF')
pickle.dump(rfc, open(filename, 'wb'))

ax = plt.gca()
rfc_disp = plot_roc_curve(rfc, X_test, y_test, ax=ax, alpha=0.8)
plt.show()




filename="model_train_test_split_1_1_tree_RF"
loaded_model = pickle.load(open(filename, 'rb'))
print (loaded_model)


blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']


clff = ExtraTreesClassifier(n_estimators=50)
clff = clff.fit(Z, z)
clff.feature_importances_  
modell = SelectFromModel(clf, prefit=True)
Z_new = modell.transform(Z)

print(Z_new.shape)


result = loaded_model.score(Z_new,z)
print(result)

pred_blind_xgb=loaded_model.predict(Z_new)
print("Random Forest Blind Validation classification report: " , classification_report(z, pred_blind_xgb))

tn, fp, fn, tp=confusion_matrix(z, pred_blind_xgb).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_xgb)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)

ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z_new, z, ax=ax, alpha=0.8)
plt.show()
