###############################
## ABDpred Server
## Version 1.0
###############################



import numpy as np
import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
from sklearn import metrics
from sklearn.svm import LinearSVC
from sklearn import datasets, metrics, model_selection, svm
from sklearn.svm import LinearSVC
from sklearn.metrics import roc_curve, auc, plot_roc_curve
import pickle
import matplotlib.pyplot as plt
from sklearn.model_selection import cross_val_score


#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)



X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)

SVM_clf = svm.SVC(C=350, gamma= 0.00001, kernel='rbf').fit(X_train, y_train)
print ("SVM classifier Training score: ", SVM_clf.score (X_test, y_test))
pred_SVM=SVM_clf.predict(X_test)
print("SVM classification report: ", classification_report(y_test, pred_SVM))
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_SVM)
print ("AUC Values: ", metrics.auc(fpr, tpr))

tn, fp, fn, tp=confusion_matrix(y_test, pred_SVM).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
roc_auc= auc(fpr, tpr)


print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)


filename = ('model_train_test_split_1_1_SVM')
pickle.dump(SVM_clf, open(filename, 'wb'))


#plot_confusion_matrix(rfc, X_test, y_test)

ax = plt.gca()
rfc_disp = plot_roc_curve(SVM_clf, X_test, y_test, ax=ax, alpha=0.8)
#plt.savefig('plot2.png')
plt.show() 



filename="model_train_test_split_1_1_SVM"
loaded_model = pickle.load(open(filename, 'rb'))
print (loaded_model)





blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']


result = loaded_model.score(Z,z)
print(result)

pred_SVM_blind=loaded_model.predict(Z)
print("SVM Blind Validation classification report: " , classification_report(z, pred_SVM_blind))


tn, fp, fn, tp=confusion_matrix(z, pred_SVM_blind).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_SVM_blind)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)

ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z, z, ax=ax, alpha=0.8)
plt.show()



