###############################
## ABDpred Server
## Version 1.0
###############################


import pandas as pd
import numpy as np
import seaborn as sns
import xgboost as xgb
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.metrics import roc_curve, auc
from sklearn import metrics
import pickle
import matplotlib.pyplot as plt
from sklearn.metrics import plot_roc_curve


filename="model_XGB_5_fold_pubchem_1_1"
loaded_model = pickle.load(open(filename, 'rb'))
#print (loaded_model)

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
result = loaded_model.score(Z,z)
print(result)

pred_blind_xgb=loaded_model.predict(Z)
print("XGBoost Blind Validation classification report: " , classification_report(z, pred_blind_xgb))

tn, fp, fn, tp=confusion_matrix(z, pred_blind_xgb).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_xgb)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)


#ax = plt.gca()
#rfc_disp1 = plot_roc_curve(loaded_model, Z, z, ax=ax, alpha=0.8)
#plt.show()

pred_blind_xgb=loaded_model.predict(Z)
print (pred_blind_xgb)

#if pred_blind_xgb=='1':
    #print ("positive")
print(pred_blind_xgb[2])
print(pred_blind_xgb.shape)
a=pred_blind_xgb.shape
t=len(pred_blind_xgb)
for i in range(t):
    if pred_blind_xgb[i]==1:
        print ("positive")
    else:
        print ("negative")
        
poss=loaded_model.predict_proba(Z)[:,1] 
neg=loaded_model.predict_proba(Z)[:,0]        
print (poss)
print (neg)   
    
    
