###############################
## ABDpred Server
## Version 1.0
###############################



import numpy as np
import seaborn as sns
import matplotlib.pyplot as plt
from sklearn.svm import SVC
from sklearn import svm
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.preprocessing import StandardScaler, LabelEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
import matplotlib.pyplot as plt  # doctest: +SKIP
from sklearn import datasets, metrics, model_selection, svm
from sklearn.metrics import plot_roc_curve
from sklearn.svm import LinearSVC
from sklearn.feature_selection import SelectFromModel
import xgboost as xgb
from sklearn import metrics
import pandas as pd
from sklearn.metrics import roc_curve, auc
import pickle
#from sklearn.feature_selection import GenericUnivariateSelect, chi2
from sklearn.feature_selection import SelectPercentile, chi2

dataset = pd.read_csv(r'train_1_1_work_2.csv',sep=',')


#print (dataset)

X= dataset.drop('Label',axis=1)
y= dataset['Label']




print (X[:1])
print (X.shape)
print (y.shape)
#self._check_params(X, y)
X_new = SelectPercentile(chi2, percentile=30).fit_transform(X, y)
#X_new = SelectPercentile(chi2, percentile=30).fit_transform(X, y)
#X_new = transformer.fit_transform(X,y)
print (X_new.shape)
#print (X_new[:2])






X_train, X_test, y_train, y_test = train_test_split(X_new,y, test_size=0.20, random_state=92)



xgb_classifier=xgb.XGBClassifier(learning_rate =0.1, n_estimators=1000, max_depth=5,min_child_weight=1, gamma=0, subsample=0.8, colsample_bytree=0.80, objective= 'binary:logistic', nthread=4, scale_pos_weight=1, seed=27)
xgb_classifier.fit(X_train, y_train)
print ("XGboost classifier Training_Testing Scores: ", xgb_classifier.score (X_test, y_test))
predictions=  xgb_classifier.predict(X_test)

print("XGboost classifier  Training_Testingset classification_report:  ", classification_report(y_test, predictions))

fpr, tpr, thresholds = metrics.roc_curve(y_test, predictions)
print ("AUC Values: ", metrics.auc(fpr, tpr))

print ("XGboost Training classifier Scores: \n", xgb_classifier.score (X_test,y_test))
pred_xgb_classifier=xgb_classifier.predict(X_test)
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_xgb_classifier)
print ("Threshold value: ", thresholds)
print("Random Forest Training report: " , classification_report(y_test, pred_xgb_classifier))
print ("AUC Values: ", metrics.auc(fpr, tpr))
print (confusion_matrix(y_test, pred_xgb_classifier).ravel())
tn, fp, fn, tp=confusion_matrix(y_test, pred_xgb_classifier).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
roc_auc= auc(fpr, tpr)


print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")

print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)

filename = ('model_train_test_split_1_1_univariate_percentile')
pickle.dump(xgb_classifier, open(filename, 'wb'))

ax = plt.gca()
rfc_disp = plot_roc_curve(xgb_classifier, X_test, y_test, ax=ax, alpha=0.8)
plt.show()






filename="model_train_test_split_1_1_univariate_percentile"
loaded_model = pickle.load(open(filename, 'rb'))
print (loaded_model)

blindset= pd.read_csv(r'blind_1_1_work_2.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']




Z_new = SelectPercentile(chi2, percentile=30).fit_transform(Z, z)
print (Z_new.shape)


result = loaded_model.score(Z_new,z)
print(result)

pred_blind_xgb=loaded_model.predict(Z_new)
print("XGBoost Blind Validation classification report: " , classification_report(z, pred_blind_xgb))

tn, fp, fn, tp=confusion_matrix(z, pred_blind_xgb).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_xgb)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)

ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z_new, z, ax=ax, alpha=0.8)
plt.show()





