###############################
## ABDpred Server
## Version 1.0
###############################



from numpy import arange
from numpy import argmax
from sklearn.datasets import make_classification
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import train_test_split
from sklearn.metrics import f1_score
 
# apply threshold to positive probabilities to create labels
def to_labels(pos_probs, threshold):
	return (pos_probs >= threshold).astype('int')
 
# generate dataset


import pandas as pd
import numpy as np
import seaborn as sns
import xgboost as xgb
from sklearn.model_selection import StratifiedKFold
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.metrics import roc_curve, auc
from sklearn import metrics
import pickle
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
from sklearn.metrics import roc_curve, auc
from sklearn.metrics import plot_roc_curve


#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)






xgb_classifier=xgb.XGBClassifier(learning_rate =0.1, n_estimators=1000, max_depth=5,min_child_weight=1, 
    gamma=0, subsample=0.8, colsample_bytree=0.80, objective= 'binary:logistic', 
    nthread=4, scale_pos_weight=1, seed=27)



# split into train/test sets
trainX, testX, trainy, testy = train_test_split(X, y, test_size=0.20, random_state=2, stratify=y)
# fit a model
model = xgb_classifier=xgb.XGBClassifier(learning_rate =0.1, n_estimators=1000, max_depth=5,min_child_weight=1, 
    gamma=0, subsample=0.8, colsample_bytree=0.80, objective= 'binary:logistic', 
    nthread=4, scale_pos_weight=1, seed=27)
model.fit(trainX, trainy)
# predict probabilities
yhat = model.predict_proba(testX)
# keep probabilities for the positive outcome only
probs = yhat[:, 1]
# define thresholds
thresholds = arange(0, 1, 0.0001)
# evaluate each threshold
scores = [f1_score(testy, to_labels(probs, t)) for t in thresholds]
#print (scores)
# get best threshold
ix = argmax(scores)
print('Threshold=%.3f, F-Score=%.5f' % (thresholds[ix], scores[ix]))