###############################
## ABDpred Server
## Version 1.0
###############################



import numpy as np
import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
from sklearn import metrics
import matplotlib.pyplot as plt
import seaborn as sns
from keras.utils import plot_model  
from sklearn.metrics import plot_confusion_matrix
from sklearn.metrics import roc_curve, auc
from sklearn.metrics import plot_roc_curve


dataset = pd.read_csv(r'data\train_1_1_work_1.csv',sep=',')
X= dataset.drop('Label',axis=1)
y= dataset['Label']

print(X.shape)


X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)


rfc = RandomForestClassifier( n_estimators= 200, random_state=92, bootstrap=True, max_features= 'sqrt')
rfc.fit(X_train,y_train)
print ("Random Forest Training classifier Scores: \n", rfc.score (X_test,y_test))
pred_rfc=rfc.predict(X_test)
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_rfc)
print ("Threshold value: ", thresholds)
print("Random Forest Training report: " , classification_report(y_test, pred_rfc))
print ("AUC Values: ", metrics.auc(fpr, tpr))
print (confusion_matrix(y_test, pred_rfc).ravel())
tn, fp, fn, tp=confusion_matrix(y_test, pred_rfc).ravel()
print (tn)
print (fp)
print (fn)
print (tp)
specificity=(tn/1.0)/(fp+tn)
print ("specificity",specificity)
sensitivity = (tp)/(tp+fn)
print ("sensitivity", sensitivity)
accuracy=(tp+tn)/(tp+fp+fn+tn)
print ("accuracy", accuracy)
f1_score=(2*tp)/(2*tp+fp+fn)
print ("f1 score:", f1_score)
precision=(tp)/(tp+fp)
print ("precision:", precision)


#plot_confusion_matrix(rfc, X_test, y_test) # doctest: +SKIP


    
roc_auc= auc(fpr, tpr)
print ("AUC value: ",roc_auc)
ax = plt.gca()

rfc_disp = plot_roc_curve(rfc, X_test, y_test, ax=ax, alpha=0.8)
plt.savefig('plot2.png')
#plt.show()  # doctest: +SKIP