from scipy.stats import sem
from numpy import mean
from numpy import std
from sklearn.datasets import make_classification
from sklearn.model_selection import RepeatedKFold
from sklearn.model_selection import cross_val_score
from sklearn.linear_model import LogisticRegression
from matplotlib import pyplot
import pandas as pd
import xgboost as xgb
 
 
 
dataset = pd.read_csv(r'data\train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Level',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Level'
y= dataset['Level']
print ("Shape of the lablled data for y",y.shape)
 
# evaluate a model with a given number of repeats
def evaluate_model(X, y, repeats):
	# prepare the cross-validation procedure
	cv = RepeatedKFold(n_splits=5, n_repeats=repeats, random_state=1)
	# create model
	model = clf = xgb_classifier=xgb.XGBClassifier(learning_rate =0.1, n_estimators=1000, max_depth=5,min_child_weight=1, gamma=0, subsample=0.8, colsample_bytree=0.80, objective= 'binary:logistic', nthread=4, scale_pos_weight=1, seed=27)
	# evaluate model
	scores = cross_val_score(model, X, y, scoring='accuracy', cv=cv, n_jobs=-1)
	return scores
 
# create dataset
X, y = make_classification(n_samples=1000, n_features=20, n_informative=15, n_redundant=5, random_state=1)
# configurations to test
repeats = range(1,6)
results = list()
for r in repeats:
	# evaluate using a given number of repeats
	scores = evaluate_model(X, y, r)
	# summarize
	print('>%d mean=%.4f se=%.3f' % (r, mean(scores), sem(scores)))
	# store
	results.append(scores)
# plot the results
pyplot.boxplot(results, labels=[str(r) for r in repeats], showmeans=True)
pyplot.show()